function [Xedge] = UGM_makeEdgeFeatures(X,edgeEnds)
% X(instance,feature,node)
% edgeEnds(edge,[node1 node2])

[nInstances,nFeatures,nNodes] = size(X);
nEdges = size(edgeEnds,1);

nEdgeFeatures = nFeatures;

% Compute Edge Features (use absolute difference between node features)
Xedge = zeros(nInstances,nEdgeFeatures,nEdges);
for i = 1:nInstances
    for e = 1:nEdges
        n1 = edgeEnds(e,1);
        n2 = edgeEnds(e,2);
        Xedge(i,:,e) = 1./(1+abs(X(i,:,n1)-X(i,:,n2)));
    end
end